#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>

struct nodo
{   
   int *info;
   struct nodo *next;
};

typedef struct nodo *Stack;

void clearStack(Stack *ps) 
{
   Stack tmp;
   while ((*ps) != NULL) 
     {
	tmp = *ps;
	*ps = (*ps)->next;
	free(tmp);
     }
}

int isEmptyStack(Stack s) 
{
   if (s == NULL)
     return 1;
   else
     return 0;
}


int pushStack(Stack *ps, int *value) 
{
   Stack tmp = (Stack) malloc(sizeof(struct nodo));
   if (tmp == NULL) 
     {
	return 0;
     }
   else 
     {
	
	tmp->info = value;
	tmp->next = *ps;
	*ps = tmp;
	return 1;
     }
   
}


int *peekStack(Stack s) 
{
   
   if (isEmptyStack(s))
     return (int *) NULL;
   else
     return s->info;
}


int popStack(Stack *ps) 
{
   Stack tmp;
   if (isEmptyStack(*ps))
     return 0;
   else 
     {
	tmp = *ps;
	*ps = (*ps)->next;
	free(tmp);
	return 1;
     }
   
}


void printStack(Stack s) 
{
   if (isEmptyStack(s)) 
     {
	printf("#");
     }
   else 
     {
	printStack(s->next);
	printf("%d",*(s->info));
     }
   
}


int main(void) 
{
   
   Stack s=NULL;
   int *pi;
   int i;
  
   printStack(s);
   for (i = 0; i < 5; i++) 
     {
	
	pi = (int *) malloc(sizeof(int));
	*pi = i;
	pushStack(&s, pi);
	printf("\ninserito %d\n",i);
	printStack(s);
     }
   
   printf("\ninserimento terminato\n");
   while (!isEmptyStack(s)) 
     {
	pi = peekStack(s);
	printf("preso: %5d\n",*pi);
	popStack(&s);
	printStack(s);
	printf("\n");
     }
   
}

